<?PHP

require_once("../../config.php");

if(isset($_SERVER["REMOTE_USER"]))
{
	$username = $_SERVER["REMOTE_USER"];


	
 session_start();
 $user = authenticate_user_login($username, null);


 if($user) 
 {
	 add_to_log(SITEID, 'user', 'login', "view.php?id=$USER->id&course=".SITEID, $user->id, 0, $user->id);
	 if(function_exists("complete_user_login"))	 
	  $USER = complete_user_login($user);
	 else
	  $USER = $user; 

	 if(isset($SESSION->wantsurl))
	  header("Location: ".$SESSION->wantsurl);
	 else 
	  header("Location: ".$CFG->wwwroot);
 }
 else // strange, we do not have $user object, but $_SERVER["REMOTE_USER"] is defined, so pubcookie's working
 {
	 $record = get_record("user", "username", $username);
	 if($record->auth != "pubcookie") // "intelligent" user auth plugin handling
	 {		 
		 $config = get_config("auth/pubcookie"); // we need to know the child plugin, if it is specified
		 if(!empty($config->pubcookie_childplugin)) // child plugin is specified, let's do some AI :)
		 {
			 if($record->auth == $config->pubcookie_childplugin) // we recognize only users that have child plugin as auth plugin
			 {
				 // Sehr gut! Updating user record, setting his authtype to pubcookie
				 set_field("user", "auth", "pubcookie", "id", $record->id);
				 add_to_log(SITEID, "user", "convert", "view.php?id=$record->id&course=".SITEID, $record->username, 0, $record->id);

				 // reauthenticate...
				 $user = authenticate_user_login($username, null);
				 if($user)
				 {
					 add_to_log(SITEID, 'user', 'login', "view.php?id=$USER->id&course=".SITEID, $user->id, 0, $user->id);
					 if(function_exists("complete_user_login"))
					  $USER = complete_user_login($user);
					 else
					  $USER = $user;

					 if(isset($SESSION->wantsurl))
 					  header("Location: ".$SESSION->wantsurl);
					 else
					  header("Location: ".$CFG->wwwroot);
				 }
				 else
				  error("Authenticate_user_login() function did not work. Unknown error.");
			 }
			 else
			 {
				 error("Authenticate_user_login() function did not work. This user has other auth plugin.");
			 }

		 }
		 else
		 {
			 error("Authenticate_user_login() function did not work. This user does not have pubcookie auth plugin, and also child plugin is not specified.");
		 }
	 }
	 else
	 {
          error("Authenticate_user_login() function did not work. Unknown error.");
	 }
 } 
}
else // no REMOTE_USER variable...
{
 $config = get_config("auth/pubcookie");
 if($config->pubcookie_installed) // pubcookie installed. But it seems there's no .htaccess file
 {
	 error("Pubcookie module failed to save its configuration. It can not create or write the moodle/auth/pubcookie/.htaccess file. Please correct the file permissions and reconfigure the module, or write the file manually.");
 }
 else
 { 
	 error("Pubcookie module failed to install. File moodle/lang/en_utf8/auth.php is not writable by your web server. Please change its access rights.");
 }
}

?>
